import "input.dart";

class Bindings<T> {
  final Map<KeyInput, T> _bindings = Map();

  Function(PointInput) pointInputMapper;

  void bind(T input, KeyInput key) {
    _bindings[key] = input;
  }

  T find(Input input) {
    if (input == null) return null;

    if (input is PointInput) return pointInputMapper(input);

    return _bindings[input];
  }
}
