import 'package:utilary/utilary.dart' show Vector;
import 'terminal.dart';
import 'glyph.dart';

class SubTerminal extends Terminal{
  final int _x;
  final int _y;
  final Terminal _parent;

  SubTerminal(this._x, this._y, int width, int height, this._parent) : super(width, height);

  @override
  void setGlyph(int x, int y, Glyph glyph) => _parent.setGlyph(_x + x, _y + y, glyph);

  @override
  SubTerminal sub(int x, int y, int width, int height) {
    if(size.contains(Vector(x, y)) && size.contains(Vector(x + width, y + height)))
      return SubTerminal(_x + x, _y + y, width, height, _parent);
    
    throw ArgumentError("Can't create a subTerminal that's out of this terminal's bounds");
  }
}